#include "AFLR2_LIB.h"

/* Table of constant values */


/* Subroutine */ int g2w012(FILE *grid_file, int *mtwgrid, int *
	m3wgrid, int *nbface, int *nelem, int *nplane, int *
	npoin, int *merror, int *ipibf, int *ipiel, double *
	dx3, double *x)
{
    /* System generated locals */
    int i__1, i__2, i__3;

    /* Local variables */
    double x3;
    int id, id1, id2;
    double rc0, dx1, dx2, dss;
    int ntet, ielem, idmax, ntria, ipoin, ipoin1, ipoin2, ipoin3, 
	    jpoin1, jpoin2, jpoin3, ipoin4, jpoin4, jpoin5, jpoin6, ibface, 
	    iplane, ipoinm;
    double dssmin;
    int nstria, nppoin, ntpoin;

/* AFLR : ADVANCING-FRONT/LOCAL-RECONNECTION UNSTRUCTURED GRID GENERATOR */
/* 2D Version : $Id: g2w012.c,v 1.7 2020/02/14 23:21:04 marcum Exp $ */
/* Copyright 1994-2016, David L. Marcum */
    /* Parameter adjustments */
    ipibf -= 5;
    ipiel -= 4;
    x -= 3;

    /* Function Body */
    rc0 = 0.;
    if (*mtwgrid == 1 && *m3wgrid == 2) {
	if (*dx3 == rc0) {
	    i__1 = *nbface;
	    for (ibface = 1; ibface <= i__1; ++ibface) {
		ipoin1 = ipibf[(ibface << 2) + 1];
		ipoin2 = ipibf[(ibface << 2) + 2];
		dx1 = x[(ipoin2 << 1) + 1] - x[(ipoin1 << 1) + 1];
		dx2 = x[(ipoin2 << 1) + 2] - x[(ipoin1 << 1) + 2];
		dss = dx1 * dx1 + dx2 * dx2;
		if (ibface == 1) {
		    dssmin = dss;
		} else {
		    dssmin = MIN(dss,dssmin);
		}
	    }
	    *dx3 = sqrt(dssmin);
	}
	ntria = *nelem;
	nstria = (ntria + (*nplane - 1) * (*nbface)) << 1;
	ntpoin = *npoin * *nplane;
	ntet = ntria * 3 * (*nplane - 1);
	fprintf (grid_file, "%i %i %i\n", ntpoin, nstria,ntet);
	i__2 = *nplane;
	for (iplane = 1; iplane <= i__2; ++iplane) {
	    i__3 = *npoin;
	    for (ipoin = 1; ipoin <= i__3; ++ipoin) {
		fprintf (grid_file, "%25.16g\n", x[(ipoin << 1) + 1]);
	    }
	}
	i__3 = *nplane;
	for (iplane = 1; iplane <= i__3; ++iplane) {
	    i__2 = *npoin;
	    for (ipoin = 1; ipoin <= i__2; ++ipoin) {
		fprintf (grid_file, "%25.16g\n", x[(ipoin << 1) + 2]);
	    }
	}
	i__1 = *nplane;
	for (iplane = 1; iplane <= i__1; ++iplane) {
	    x3 = *dx3 * (double) (iplane - 1);
	    i__3 = *npoin;
	    for (ipoin = 1; ipoin <= i__3; ++ipoin) {
		fprintf (grid_file, "%25.16g\n", x3);
	    }
	}
	nppoin = *npoin * (*nplane - 1);
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
            fprintf (grid_file, "%i %i %i\n", ipoin2, ipoin1, ipoin3);
	    jpoin1 = ipoin1 + nppoin;
	    jpoin2 = ipoin3 + nppoin;
	    jpoin3 = ipoin2 + nppoin;
            fprintf (grid_file, "%i %i %i\n", jpoin2, jpoin1, jpoin3);
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 2];
	    ipoin2 = ipibf[(ibface << 2) + 1];
	    if (ipoin1 < ipoin2) {
		i__2 = *nplane - 1;
		for (iplane = 1; iplane <= i__2; ++iplane) {
		    ipoin3 = ipoin2 + *npoin;
		    ipoin4 = ipoin1 + *npoin;
                    fprintf (grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin4);
                    fprintf (grid_file, "%i %i %i\n", ipoin2, ipoin3, ipoin4);
		    ipoin1 = ipoin4;
		    ipoin2 = ipoin3;
		}
	    } else {
		i__2 = *nplane - 1;
		for (iplane = 1; iplane <= i__2; ++iplane) {
		    ipoin3 = ipoin2 + *npoin;
		    ipoin4 = ipoin1 + *npoin;
                    fprintf (grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
                    fprintf (grid_file, "%i %i %i\n", ipoin1, ipoin3, ipoin4);
		    ipoin1 = ipoin4;
		    ipoin2 = ipoin3;
		}
	    }
	}
	idmax = ipibf[8];
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    id = ipibf[(ibface << 2) + 4];
	    idmax = MAX(id,idmax);
	}
	id1 = idmax + 1;
	id2 = idmax + 2;
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    fprintf(grid_file, "%i\n", id1);
	    fprintf(grid_file, "%i\n", id2);
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    id = ipibf[(ibface << 2) + 4];
	    i__2 = *nplane - 1;
	    for (iplane = 1; iplane <= i__2; ++iplane) {
	        fprintf(grid_file, "%i\n", id);
	        fprintf(grid_file, "%i\n", id);
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
/* Computing MIN */
	    i__2 = MIN(ipoin1,ipoin2);
	    ipoinm = MIN(i__2,ipoin3);
	    if (ipoin1 == ipoinm) {
		jpoin1 = ipoin1;
		jpoin2 = ipoin2;
		jpoin3 = ipoin3;
	    } else {
		if (ipoin2 == ipoinm) {
		    jpoin1 = ipoin2;
		    jpoin2 = ipoin3;
		    jpoin3 = ipoin1;
		} else {
		    jpoin1 = ipoin3;
		    jpoin2 = ipoin1;
		    jpoin3 = ipoin2;
		}
	    }
	    if (jpoin2 < jpoin3) {
		i__2 = *nplane - 1;
		for (iplane = 1; iplane <= i__2; ++iplane) {
		    jpoin4 = jpoin1 + *npoin;
		    jpoin5 = jpoin2 + *npoin;
		    jpoin6 = jpoin3 + *npoin;
		    fprintf(grid_file, "%i %i %i %i\n", jpoin1, jpoin2, jpoin3, jpoin4);
		    fprintf(grid_file, "%i %i %i %i\n", jpoin2, jpoin3, jpoin4, jpoin5);
		    fprintf(grid_file, "%i %i %i %i\n", jpoin3, jpoin4, jpoin5, jpoin6);
		    jpoin1 = jpoin4;
		    jpoin2 = jpoin5;
		    jpoin3 = jpoin6;
		}
	    } else {
		i__2 = *nplane - 1;
		for (iplane = 1; iplane <= i__2; ++iplane) {
		    jpoin4 = jpoin1 + *npoin;
		    jpoin5 = jpoin2 + *npoin;
		    jpoin6 = jpoin3 + *npoin;
		    fprintf(grid_file, "%i %i %i %i\n", jpoin1, jpoin2, jpoin3, jpoin4);
		    fprintf(grid_file, "%i %i %i %i\n", jpoin3, jpoin4, jpoin2, jpoin6);
		    fprintf(grid_file, "%i %i %i %i\n", jpoin2, jpoin6, jpoin4, jpoin5);
		    jpoin1 = jpoin4;
		    jpoin2 = jpoin5;
		    jpoin3 = jpoin6;
		}
	    }
	}
	*merror = 0;
    }
    return 0;
} /* g2w012_ */

