#include "AFLR2_LIB.h"

/* Subroutine */ int g2w021(FILE *grid_file, int *mtwgrid, int *
	m3wgrid, int *nbface, int *nelem, int *nplane, int *
	npoin, int *nquad, int *merror, int *ipibf, int *
	ipiel, int *ipiq, int *npip, double *dang, double *x)
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    double r__, x1, x2, x3;
    int id, id1, id2;
    double rc0, rc1, ang;
    int ncl;
    double rc45, ang0, pid4;
    int nhex, ntet;
    double dang0;
    int npip0, npip1, npip2, npip3, npip4, ielem, iquad, idmax, 
	    ipoin, jpoin, ipoin1, ipoin2, ipoin3, ipoin4, jpoin1, jpoin2, 
	    jpoin3, jpoin4, jpoin5, jpoin6, ibface, npent5, npent6, iplane, 
	    nquadm, ntriam, nsquad, nstria, nppoin, ntpoin, nplane1, nplane2;

    /* Fortran I/O blocks */


/* AFLR : ADVANCING-FRONT/LOCAL-RECONNECTION UNSTRUCTURED GRID GENERATOR */
/* 2D Version : $Id: g2w021.c,v 1.7 2020/02/14 23:21:04 marcum Exp $ */
/* Copyright 1994-2016, David L. Marcum */
    /* Parameter adjustments */
    ipibf -= 5;
    ipiel -= 4;
    x -= 3;
    --npip;
    ipiq -= 5;

    /* Function Body */
    rc0 = 0.;
    rc1 = 1.;
    rc45 = 45.;
    if (*mtwgrid == 2 && *m3wgrid == 1) {
	nplane1 = *nplane - 1;
	nplane2 = *nplane - 2;
	pid4 = atan(rc1);
	dang0 = *dang * pid4 / rc45;
	ang0 = pid4 + pid4 + dang0 * (double) (*nplane - 1);
	jpoin = 0;
	ncl = 0;
	i__1 = *npoin;
	for (ipoin = 1; ipoin <= i__1; ++ipoin) {
	    if (x[(ipoin << 1) + 2] == rc0) {
		++ncl;
		npip[ipoin] = 0;
	    } else {
		++jpoin;
		npip[ipoin] = *npoin + jpoin - ipoin;
	    }
	}
	nppoin = *npoin - ncl;
	ntpoin = *npoin + nplane1 * nppoin;
	nquadm = *nquad;
	ntriam = *nelem;
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    ipoin2 = ipiq[(iquad << 2) + 2];
	    ipoin3 = ipiq[(iquad << 2) + 3];
	    ipoin4 = ipiq[(iquad << 2) + 4];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
	    npip4 = npip[ipoin4];
	    if ((npip1 == 0 && npip2 > 0 && npip3 > 0 && npip4 > 0) || (npip2 == 
		    0 && npip1 > 0 && npip3 > 0 && npip4 > 0) || (npip3 == 0 && 
		    npip2 > 0 && npip1 > 0 && npip4 > 0) || (npip4 == 0 && 
		    npip2 > 0 && npip3 > 0 && npip1 > 0)) {
		--nquadm;
		ntriam += 2;
		ipiq[(iquad << 2) + 1] = -ipoin1;
	    }
	}
	nstria = ntriam << 1;
	nsquad = nquadm << 1;
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 1];
	    ipoin2 = ipibf[(ibface << 2) + 2];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    if ((npip1 == 0 || npip2 == 0) && (npip1 > 0 || npip2 > 0)) {
		nstria += nplane1;
	    }
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 2];
	    ipoin2 = ipibf[(ibface << 2) + 1];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    if (npip1 > 0 && npip2 > 0) {
		nsquad += nplane1;
	    }
	}
	ntet = 0;
	npent5 = 0;
	npent6 = 0;
	nhex = 0;
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
	    if ((npip1 == 0 && npip2 == 0) || (npip2 == 0 && npip3 == 0) || (npip3 
		    == 0 && npip1 == 0)) {
		ntet += nplane1;
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
	    if ((npip1 == 0 && npip2 > 0 && npip3 > 0) || (npip2 == 0 && npip3 > 
		    0 && npip1 > 0) || (npip3 == 0 && npip1 > 0 && npip2 > 0)) {
		npent5 += nplane1;
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 < 0) {
		npent5 += nplane1;
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
/* Computing MIN */
	    i__2 = MIN(npip1,npip2);
	    npip0 = MIN(i__2,npip3);
	    if (npip0 > 0) {
		npent6 += nplane1;
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 < 0) {
		npent6 += nplane1;
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 > 0) {
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		npip4 = npip[ipoin4];
		if ((npip1 == 0 && npip2 == 0) || (npip2 == 0 && npip3 == 0) || 
			(npip3 == 0 && npip4 == 0) || (npip4 == 0 && npip1 == 0)) 
			{
		    npent6 += nplane1;
		}
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 > 0) {
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		npip4 = npip[ipoin4];
/* Computing MIN */
		i__2 = MIN(npip1,npip2), i__2 = MIN(i__2,npip3);
		npip0 = MIN(i__2,npip4);
		if (npip0 > 0) {
		    nhex += nplane1;
		}
	    }
	}
	fprintf (grid_file, "%i %i %i %i %i %i %i\n", ntpoin, nstria, nsquad, ntet, npent5, npent6, nhex);
	i__1 = *nplane;
	for (iplane = 1; iplane <= i__1; ++iplane) {
	    ang = ang0 - dang0 * (double) (iplane - 1);
	    i__2 = *npoin;
	    for (ipoin = 1; ipoin <= i__2; ++ipoin) {
		if (iplane == 1 || npip[ipoin] > 0) {
		    r__ = x[(ipoin << 1) + 2];
		    x1 = x[(ipoin << 1) + 1];
		    x2 = r__ * sin(ang);
		    x3 = r__ * cos(ang);
		    fprintf (grid_file, "%25.16g %25.16g %25.16g\n", x1, x2, x3);
		}
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
            fprintf (grid_file, "%i %i %i\n", ipoin2, ipoin1, ipoin3);
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
	    ipoin1 += npip1;
	    ipoin2 += npip2;
	    ipoin3 += npip3;
            fprintf (grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 < 0) {
		ipoin1 = -ipoin1;
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		if (npip1 == 0) {
		    jpoin1 = ipoin1;
		    jpoin2 = ipoin2;
		    jpoin3 = ipoin3;
		    jpoin4 = ipoin4;
		} else {
		    if (npip2 == 0) {
			jpoin1 = ipoin2;
			jpoin2 = ipoin3;
			jpoin3 = ipoin4;
			jpoin4 = ipoin1;
		    } else {
			if (npip3 == 0) {
			    jpoin1 = ipoin3;
			    jpoin2 = ipoin4;
			    jpoin3 = ipoin1;
			    jpoin4 = ipoin2;
			} else {
			    jpoin1 = ipoin4;
			    jpoin2 = ipoin1;
			    jpoin3 = ipoin2;
			    jpoin4 = ipoin3;
			}
		    }
		}
                fprintf (grid_file, "%i %i %i\n", jpoin2, jpoin1, jpoin4);
                fprintf (grid_file, "%i %i %i\n", jpoin3, jpoin2, jpoin4);
		npip1 = npip[jpoin1];
		npip2 = npip[jpoin2];
		npip3 = npip[jpoin3];
		npip4 = npip[jpoin4];
		jpoin1 += npip1;
		jpoin2 += npip2;
		jpoin3 += npip3;
		jpoin4 += npip4;
		if (npip1 > 0) {
		    jpoin1 += nplane2 * nppoin;
		}
		if (npip2 > 0) {
		    jpoin2 += nplane2 * nppoin;
		}
		if (npip3 > 0) {
		    jpoin3 += nplane2 * nppoin;
		}
		if (npip4 > 0) {
		    jpoin4 += nplane2 * nppoin;
		}
                fprintf (grid_file, "%i %i %i\n", jpoin1, jpoin2, jpoin4);
                fprintf (grid_file, "%i %i %i\n", jpoin2, jpoin3, jpoin4);
	    }
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 1];
	    ipoin2 = ipibf[(ibface << 2) + 2];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    if ((npip1 == 0 || npip2 == 0) && (npip1 > 0 || npip2 > 0)) {
		if (npip1 == 0) {
		    ipoin3 = ipoin2 + npip2;
                    fprintf (grid_file, "%i %i %i\n", ipoin3, ipoin1, ipoin2);
		    ipoin2 = ipoin3;
		    i__2 = nplane1;
		    for (iplane = 2; iplane <= i__2; ++iplane) {
			ipoin3 = ipoin2 + nppoin;
                        fprintf (grid_file, "%i %i %i\n", ipoin3, ipoin1, ipoin2);
			ipoin2 = ipoin3;
		    }
		} else {
		    ipoin3 = ipoin1 + npip1;
                    fprintf (grid_file, "%i %i %i\n", ipoin3, ipoin1, ipoin2);
		    ipoin1 = ipoin3;
		    i__2 = nplane1;
		    for (iplane = 2; iplane <= i__2; ++iplane) {
			ipoin3 = ipoin1 + nppoin;
                        fprintf (grid_file, "%i %i %i\n", ipoin3, ipoin1, ipoin2);
			ipoin1 = ipoin3;
		    }
		}
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 > 0) {
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
                fprintf (grid_file, "%i %i %i %i\n", ipoin2, ipoin1, ipoin4, ipoin3);
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		npip4 = npip[ipoin4];
		ipoin1 += npip1;
		ipoin2 += npip2;
		ipoin3 += npip3;
		ipoin4 += npip4;
		if (npip1 > 0) {
		    ipoin1 += nplane2 * nppoin;
		}
		if (npip2 > 0) {
		    ipoin2 += nplane2 * nppoin;
		}
		if (npip3 > 0) {
		    ipoin3 += nplane2 * nppoin;
		}
		if (npip4 > 0) {
		    ipoin4 += nplane2 * nppoin;
		}
                fprintf (grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
	    }
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 2];
	    ipoin2 = ipibf[(ibface << 2) + 1];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    if (npip1 > 0 && npip2 > 0) {
		ipoin3 = ipoin2 + npip2;
		ipoin4 = ipoin1 + npip1;
                fprintf (grid_file, "%i %i %i %i\n", ipoin2, ipoin1, ipoin4, ipoin3);
		ipoin1 = ipoin4;
		ipoin2 = ipoin3;
		i__2 = nplane1;
		for (iplane = 2; iplane <= i__2; ++iplane) {
		    ipoin3 = ipoin2 + nppoin;
		    ipoin4 = ipoin1 + nppoin;
                    fprintf (grid_file, "%i %i %i %i\n", ipoin2, ipoin1, ipoin4, ipoin3);
		    ipoin1 = ipoin4;
		    ipoin2 = ipoin3;
		}
	    }
	}
	idmax = ipibf[8];
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    id = ipibf[(ibface << 2) + 4];
	    idmax = MAX(id,idmax);
	}
	id1 = idmax + 1;
	id2 = idmax + 2;
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    fprintf(grid_file, "%i\n", id1);
	    fprintf(grid_file, "%i\n", id2);
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 < 0) {
	        fprintf(grid_file, "%i\n", id1);
	        fprintf(grid_file, "%i\n", id1);
	        fprintf(grid_file, "%i\n", id2);
	        fprintf(grid_file, "%i\n", id2);
	    }
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 1];
	    ipoin2 = ipibf[(ibface << 2) + 2];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    if ((npip1 == 0 || npip2 == 0) && (npip1 > 0 || npip2 > 0)) {
		id = ipibf[(ibface << 2) + 4];
		i__2 = nplane1;
		for (iplane = 1; iplane <= i__2; ++iplane) {
	            fprintf(grid_file, "%i\n", id);
		}
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 > 0) {
	        fprintf(grid_file, "%i\n", id1);
	        fprintf(grid_file, "%i\n", id2);
	    }
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 2];
	    ipoin2 = ipibf[(ibface << 2) + 1];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    if (npip1 > 0 && npip2 > 0) {
		id = ipibf[(ibface << 2) + 4];
		i__2 = nplane1;
		for (iplane = 1; iplane <= i__2; ++iplane) {
	            fprintf(grid_file, "%i\n", id);
		}
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
	    if (npip1 == 0 && npip2 == 0) {
		jpoin1 = ipoin1;
		jpoin2 = ipoin2;
		jpoin3 = ipoin3;
	    } else {
		if (npip2 == 0 && npip3 == 0) {
		    jpoin1 = ipoin2;
		    jpoin2 = ipoin3;
		    jpoin3 = ipoin1;
		    npip3 = npip1;
		} else {
		    if (npip3 == 0 && npip1 == 0) {
			jpoin1 = ipoin3;
			jpoin2 = ipoin1;
			jpoin3 = ipoin2;
			npip3 = npip2;
		    } else {
			jpoin1 = 0;
		    }
		}
	    }
	    if (jpoin1 > 0) {
		jpoin4 = jpoin3 + npip3;
		fprintf(grid_file, "%i %i %i %i\n", jpoin1, jpoin2, jpoin3, jpoin4);
		jpoin3 = jpoin4;
		i__2 = nplane1;
		for (iplane = 2; iplane <= i__2; ++iplane) {
		    jpoin4 = jpoin3 + nppoin;
		    fprintf(grid_file, "%i %i %i %i\n", jpoin1, jpoin2, jpoin3, jpoin4);
		    jpoin3 = jpoin4;
		}
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
	    if (npip1 == 0 && npip2 > 0 && npip3 > 0) {
		jpoin1 = ipoin1;
		jpoin2 = ipoin2;
		jpoin3 = ipoin3;
	    } else {
		if (npip2 == 0 && npip3 > 0 && npip1 > 0) {
		    jpoin1 = ipoin2;
		    jpoin2 = ipoin3;
		    jpoin3 = ipoin1;
		    npip2 = npip3;
		    npip3 = npip1;
		} else {
		    if (npip3 == 0 && npip1 > 0 && npip2 > 0) {
			jpoin1 = ipoin3;
			jpoin2 = ipoin1;
			jpoin3 = ipoin2;
			npip3 = npip2;
			npip2 = npip1;
		    } else {
			jpoin1 = 0;
		    }
		}
	    }
	    if (jpoin1 > 0) {
		jpoin4 = jpoin2 + npip2;
		jpoin5 = jpoin3 + npip3;
		fprintf(grid_file, "%i %i %i %i %i\n", jpoin2, jpoin3, jpoin1, jpoin4, jpoin5);
		jpoin2 = jpoin4;
		jpoin3 = jpoin5;
		i__2 = nplane1;
		for (iplane = 2; iplane <= i__2; ++iplane) {
		    jpoin4 = jpoin2 + nppoin;
		    jpoin5 = jpoin3 + nppoin;
		    fprintf(grid_file, "%i %i %i %i %i\n", jpoin2, jpoin3, jpoin1, jpoin4, jpoin5);
		    jpoin2 = jpoin4;
		    jpoin3 = jpoin5;
		}
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 < 0) {
		ipoin1 = -ipoin1;
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		if (npip1 == 0) {
		    jpoin1 = ipoin1;
		    jpoin2 = ipoin2;
		    jpoin3 = ipoin4;
		} else {
		    if (npip2 == 0) {
			jpoin1 = ipoin2;
			jpoin2 = ipoin3;
			jpoin3 = ipoin1;
		    } else {
			if (npip3 == 0) {
			    jpoin1 = ipoin3;
			    jpoin2 = ipoin4;
			    jpoin3 = ipoin2;
			} else {
			    jpoin1 = ipoin4;
			    jpoin2 = ipoin1;
			    jpoin3 = ipoin3;
			}
		    }
		}
		npip2 = npip[jpoin2];
		npip3 = npip[jpoin3];
		jpoin4 = jpoin2 + npip2;
		jpoin5 = jpoin3 + npip3;
		fprintf(grid_file, "%i %i %i %i %i\n", jpoin2, jpoin3, jpoin1, jpoin4, jpoin5);
		jpoin2 = jpoin4;
		jpoin3 = jpoin5;
		i__2 = nplane1;
		for (iplane = 2; iplane <= i__2; ++iplane) {
		    jpoin4 = jpoin2 + nppoin;
		    jpoin5 = jpoin3 + nppoin;
		    fprintf(grid_file, "%i %i %i %i %i\n", jpoin2, jpoin3, jpoin1, jpoin4, jpoin5);
		    jpoin2 = jpoin4;
		    jpoin3 = jpoin5;
		}
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
	    npip1 = npip[ipoin1];
	    npip2 = npip[ipoin2];
	    npip3 = npip[ipoin3];
/* Computing MIN */
	    i__2 = MIN(npip1,npip2);
	    npip0 = MIN(i__2,npip3);
	    if (npip0 > 0) {
		fprintf(grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
		ipoin1 += npip1;
		ipoin2 += npip2;
		ipoin3 += npip3;
		fprintf(grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
		i__2 = nplane1;
		for (iplane = 2; iplane <= i__2; ++iplane) {
		    fprintf(grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
		    ipoin1 += nppoin;
		    ipoin2 += nppoin;
		    ipoin3 += nppoin;
		    fprintf(grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
		}
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 < 0) {
		ipoin1 = -ipoin1;
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		if (npip1 == 0) {
		    jpoin2 = ipoin2;
		    jpoin3 = ipoin3;
		    jpoin4 = ipoin4;
		} else {
		    if (npip2 == 0) {
			jpoin2 = ipoin3;
			jpoin3 = ipoin4;
			jpoin4 = ipoin1;
		    } else {
			if (npip3 == 0) {
			    jpoin2 = ipoin4;
			    jpoin3 = ipoin1;
			    jpoin4 = ipoin2;
			} else {
			    jpoin2 = ipoin1;
			    jpoin3 = ipoin2;
			    jpoin4 = ipoin3;
			}
		    }
		}
		npip2 = npip[jpoin2];
		npip3 = npip[jpoin3];
		npip4 = npip[jpoin4];
		fprintf(grid_file, "%i %i %i\n", jpoin2, jpoin3, jpoin4);
		jpoin2 += npip2;
		jpoin3 += npip3;
		jpoin4 += npip4;
		fprintf(grid_file, "%i %i %i\n", jpoin2, jpoin3, jpoin4);
		i__2 = nplane1;
		for (iplane = 2; iplane <= i__2; ++iplane) {
		    fprintf(grid_file, "%i %i %i\n", jpoin2, jpoin3, jpoin4);
		    jpoin2 += nppoin;
		    jpoin3 += nppoin;
		    jpoin4 += nppoin;
		    fprintf(grid_file, "%i %i %i\n", jpoin2, jpoin3, jpoin4);
		}
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 > 0) {
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		npip4 = npip[ipoin4];
		if (npip1 == 0 && npip2 == 0) {
		    jpoin1 = ipoin1;
		    jpoin2 = ipoin2;
		    jpoin3 = ipoin3;
		    jpoin4 = ipoin4;
		} else {
		    if (npip2 == 0 && npip3 == 0) {
			jpoin1 = ipoin2;
			jpoin2 = ipoin3;
			jpoin3 = ipoin4;
			jpoin4 = ipoin1;
			npip3 = npip4;
			npip4 = npip1;
		    } else {
			if (npip3 == 0 && npip4 == 0) {
			    jpoin1 = ipoin3;
			    jpoin2 = ipoin4;
			    jpoin3 = ipoin1;
			    jpoin4 = ipoin2;
			    npip3 = npip1;
			    npip4 = npip2;
			} else {
			    if (npip4 == 0 && npip1 == 0) {
				jpoin1 = ipoin4;
				jpoin2 = ipoin1;
				jpoin3 = ipoin2;
				jpoin4 = ipoin3;
				npip4 = npip3;
				npip3 = npip2;
			    } else {
				jpoin1 = 0;
			    }
			}
		    }
		}
		if (jpoin1 > 0) {
		    jpoin5 = jpoin3 + npip3;
		    jpoin6 = jpoin4 + npip4;
		    fprintf(grid_file, "%i %i %i %i %i %i\n", jpoin2, jpoin5, jpoin3, 
		                                              jpoin1, jpoin6, jpoin4); 
		    jpoin3 = jpoin5;
		    jpoin4 = jpoin6;
		    i__2 = nplane1;
		    for (iplane = 2; iplane <= i__2; ++iplane) {
			jpoin5 = jpoin3 + nppoin;
			jpoin6 = jpoin4 + nppoin;
		        fprintf(grid_file, "%i %i %i %i %i %i\n", jpoin2, jpoin5, jpoin3, 
		                                                  jpoin1, jpoin6, jpoin4); 
			jpoin3 = jpoin5;
			jpoin4 = jpoin6;
		    }
		}
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    if (ipoin1 > 0) {
		ipoin2 = ipiq[(iquad << 2) + 2];
		ipoin3 = ipiq[(iquad << 2) + 3];
		ipoin4 = ipiq[(iquad << 2) + 4];
		npip1 = npip[ipoin1];
		npip2 = npip[ipoin2];
		npip3 = npip[ipoin3];
		npip4 = npip[ipoin4];
/* Computing MIN */
		i__2 = MIN(npip1,npip2), i__2 = MIN(i__2,npip3);
		npip0 = MIN(i__2,npip4);
		if (npip0 > 0) {
		    fprintf(grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
		    ipoin1 += npip1;
		    ipoin2 += npip2;
		    ipoin3 += npip3;
		    ipoin4 += npip4;
		    fprintf(grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
		    i__2 = nplane1;
		    for (iplane = 2; iplane <= i__2; ++iplane) {
		        fprintf(grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
			ipoin1 += nppoin;
			ipoin2 += nppoin;
			ipoin3 += nppoin;
			ipoin4 += nppoin;
		        fprintf(grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
		    }
		}
	    }
	}
	*merror = 0;
    }
    return 0;
} /* g2w021_ */

