#include "AFLR2_LIB.h"

/* Subroutine */ int g2w022(FILE *grid_file, int *mtwgrid, int *
	m3wgrid, int *nbface, int *nelem, int *nplane, int *
	npoin, int *nquad, int *merror, int *ipibf, int *
	ipiel, int *ipiq, double *dx3, double *x)
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    double x1, x2, x3;
    int id, id1, id2;
    double rc0, dx1, dx2, dss;
    int nhex, ntet, ielem, iquad, idmax, ipoin, ipoin1, ipoin2, 
	    ipoin3, jpoin1, jpoin2, jpoin3, ipoin4, jpoin4, ibface, npent5, 
	    npent6, iplane, nsquad;
    double dssmin;
    int nstria, nppoin, ntpoin;

/* AFLR : ADVANCING-FRONT/LOCAL-RECONNECTION UNSTRUCTURED GRID GENERATOR */
/* 2D Version : $Id: g2w022.c,v 1.6 2020/02/14 23:21:04 marcum Exp $ */
/* Copyright 1994-2016, David L. Marcum */
    /* Parameter adjustments */
    ipibf -= 5;
    ipiel -= 4;
    x -= 3;
    ipiq -= 5;

    /* Function Body */
    rc0 = 0.;
    if (*mtwgrid == 2 && *m3wgrid == 2) {
	if (*dx3 == rc0) {
	    i__1 = *nbface;
	    for (ibface = 1; ibface <= i__1; ++ibface) {
		ipoin1 = ipibf[(ibface << 2) + 1];
		ipoin2 = ipibf[(ibface << 2) + 2];
		dx1 = x[(ipoin2 << 1) + 1] - x[(ipoin1 << 1) + 1];
		dx2 = x[(ipoin2 << 1) + 2] - x[(ipoin1 << 1) + 2];
		dss = dx1 * dx1 + dx2 * dx2;
		if (ibface == 1) {
		    dssmin = dss;
		} else {
		    dssmin = MIN(dss,dssmin);
		}
	    }
	    *dx3 = sqrt(dssmin);
	}
	nstria = *nelem << 1;
	nsquad = (*nquad << 1) + (*nplane - 1) * *nbface;
	ntpoin = *npoin * *nplane;
	ntet = 0;
	npent5 = 0;
	npent6 = *nelem * (*nplane - 1);
	nhex = *nquad * (*nplane - 1);
	fprintf (grid_file, "%i %i %i %i %i %i %i\n", ntpoin, nstria, nsquad, ntet, npent5, npent6, nhex);
	i__1 = *nplane;
	for (iplane = 1; iplane <= i__1; ++iplane) {
	    x3 = *dx3 * (double) (iplane - 1);
	    i__2 = *npoin;
	    for (ipoin = 1; ipoin <= i__2; ++ipoin) {
		x1 = x[(ipoin << 1) + 1];
		x2 = x[(ipoin << 1) + 2];
		fprintf (grid_file, "%25.16g %25.16g %25.16g\n", x1, x2, x3);
	    }
	}
	nppoin = *npoin * (*nplane - 1);
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
            fprintf (grid_file, "%i %i %i\n", ipoin2, ipoin1, ipoin3);
	    jpoin1 = ipoin1 + nppoin;
	    jpoin2 = ipoin3 + nppoin;
	    jpoin3 = ipoin2 + nppoin;
            fprintf (grid_file, "%i %i %i\n", jpoin2, jpoin1, jpoin3);
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    ipoin2 = ipiq[(iquad << 2) + 2];
	    ipoin3 = ipiq[(iquad << 2) + 3];
	    ipoin4 = ipiq[(iquad << 2) + 4];
            fprintf (grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
	    jpoin1 = ipoin2 + nppoin;
	    jpoin2 = ipoin1 + nppoin;
	    jpoin3 = ipoin4 + nppoin;
	    jpoin4 = ipoin3 + nppoin;
            fprintf (grid_file, "%i %i %i %i\n", jpoin1, jpoin2, jpoin3, jpoin4);
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    ipoin1 = ipibf[(ibface << 2) + 2];
	    ipoin2 = ipibf[(ibface << 2) + 1];
	    i__2 = *nplane - 1;
	    for (iplane = 1; iplane <= i__2; ++iplane) {
		ipoin3 = ipoin2 + *npoin;
		ipoin4 = ipoin1 + *npoin;
                fprintf (grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
		ipoin1 = ipoin4;
		ipoin2 = ipoin3;
	    }
	}
	idmax = ipibf[8];
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    id = ipibf[(ibface << 2) + 4];
	    idmax = MAX(id,idmax);
	}
	id1 = idmax + 1;
	id2 = idmax + 2;
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    fprintf(grid_file, "%i\n", id1);
	    fprintf(grid_file, "%i\n", id2);
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    fprintf(grid_file, "%i\n", id1);
	    fprintf(grid_file, "%i\n", id2);
	}
	i__1 = *nbface;
	for (ibface = 1; ibface <= i__1; ++ibface) {
	    id = ipibf[(ibface << 2) + 4];
	    i__2 = *nplane - 1;
	    for (iplane = 1; iplane <= i__2; ++iplane) {
	        fprintf(grid_file, "%i\n", id);
	    }
	}
	i__1 = *nelem;
	for (ielem = 1; ielem <= i__1; ++ielem) {
	    ipoin1 = ipiel[ielem * 3 + 1];
	    ipoin2 = ipiel[ielem * 3 + 2];
	    ipoin3 = ipiel[ielem * 3 + 3];
	    i__2 = *nplane - 1;
	    for (iplane = 1; iplane <= i__2; ++iplane) {
		fprintf(grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
		ipoin1 += *npoin;
		ipoin2 += *npoin;
		ipoin3 += *npoin;
		fprintf(grid_file, "%i %i %i\n", ipoin1, ipoin2, ipoin3);
	    }
	}
	i__1 = *nquad;
	for (iquad = 1; iquad <= i__1; ++iquad) {
	    ipoin1 = ipiq[(iquad << 2) + 1];
	    ipoin2 = ipiq[(iquad << 2) + 2];
	    ipoin3 = ipiq[(iquad << 2) + 3];
	    ipoin4 = ipiq[(iquad << 2) + 4];
	    i__2 = *nplane - 1;
	    for (iplane = 1; iplane <= i__2; ++iplane) {
		fprintf(grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
		ipoin1 += *npoin;
		ipoin2 += *npoin;
		ipoin3 += *npoin;
		ipoin4 += *npoin;
		fprintf(grid_file, "%i %i %i %i\n", ipoin1, ipoin2, ipoin3, ipoin4);
	    }
	}
        *merror = 0;
    }
    return 0;
} /* g2w022_ */

