void ug3_check_read_write_mesh_sol (INT_ *check_rmesh,
                                    INT_ *check_rsol,
                                    INT_ *check_wmesh,
                                    INT_ *check_wsol);

INT_ ug3_read_mesh (char File_Name[],
                    INT_ Read_Task_Flag,
                    INT_ *Number_of_Bnd_Nodes,
                    INT_ *Number_of_Nodes,
                    INT_ *Number_of_Surf_Quads,
                    INT_ *Number_of_Surf_Trias,
                    INT_ *Number_of_Vol_Hexs,
                    INT_ *Number_of_Vol_Pents_5,
                    INT_ *Number_of_Vol_Pents_6,
                    INT_ *Number_of_Vol_Tets,
                    INT_1D * Surf_ID_Flag,
                    INT_4D * Surf_Quad_Connectivity,
                    INT_3D * Surf_Tria_Connectivity,
                    INT_8D * Vol_Hex_Connectivity,
                    INT_1D * Vol_ID_Flag,
                    INT_5D * Vol_Pent_5_Connectivity,
                    INT_6D * Vol_Pent_6_Connectivity,
                    INT_4D * Vol_Tet_Connectivity,
                    DOUBLE_3D * Coordinates);

INT_ ug3_p2_read_mesh (char File_Name[],
                       INT_ Read_Task_Flag,
                       INT_ *Number_of_Bnd_Nodes,
                       INT_ *Number_of_Nodes,
                       INT_ *Number_of_Surf_Quads,
                       INT_ *Number_of_Surf_Trias,
                       INT_ *Number_of_Vol_Hexs,
                       INT_ *Number_of_Vol_Pents_5,
                       INT_ *Number_of_Vol_Pents_6,
                       INT_ *Number_of_Vol_Tets,
                       INT_ *Order,
                       INT_1D * Surf_ID_Flag,
                       INT_4D * Surf_Quad_Connectivity,
                       INT_3D * Surf_Tria_Connectivity,
                       INT_8D * Vol_Hex_Connectivity,
                       INT_1D * Vol_ID_Flag,
                       INT_5D * Vol_Pent_5_Connectivity,
                       INT_6D * Vol_Pent_6_Connectivity,
                       INT_4D * Vol_Tet_Connectivity,
                       INT_5D * P2_Surf_Quad_Connectivity,
                       INT_3D * P2_Surf_Tria_Connectivity,
                       INT_19D * P2_Vol_Hex_Connectivity,
                       INT_9D * P2_Vol_Pent_5_Connectivity,
                       INT_12D * P2_Vol_Pent_6_Connectivity,
                       INT_6D * P2_Vol_Tet_Connectivity,
                       DOUBLE_3D * Coordinates);

INT_ ug3_read_sol (char File_Name[],
                   INT_ Read_Task_Flag,
                   INT_ NDim,
                   INT_ *Number_of_Nodes,
                   INT_ *Number_of_U_Scalars,
                   INT_ *Number_of_U_Vectors,
                   INT_ *Number_of_U_Metrics,
                   INT_ *Number_of_U_SymMetrics,
                   CHAR_21 * U_Scalar_Labels,
                   CHAR_21 * U_Vector_Labels,
                   CHAR_21 * U_Metric_Labels,
                   CHAR_21 * U_SymMetric_Labels,
                   DOUBLE_1D * U_Scalars,
                   DOUBLE_1D * U_Vectors,
                   DOUBLE_1D * U_Metrics,
                   DOUBLE_1D * U_SymMetrics);

INT_ ug3_write_mesh (char File_Name[],
                     INT_ Write_Task_Flag,
                     INT_ Number_of_Nodes,
                     INT_ Number_of_Surf_Quads,
                     INT_ Number_of_Surf_Trias,
                     INT_ Number_of_Vol_Hexs,
                     INT_ Number_of_Vol_Pents_5,
                     INT_ Number_of_Vol_Pents_6,
                     INT_ Number_of_Vol_Tets,
                     INT_1D * Surf_ID_Flag,
                     INT_4D * Surf_Quad_Connectivity,
                     INT_3D * Surf_Tria_Connectivity,
                     INT_8D * Vol_Hex_Connectivity,
                     INT_1D * Vol_ID_Flag,
                     INT_5D * Vol_Pent_5_Connectivity,
                     INT_6D * Vol_Pent_6_Connectivity,
                     INT_4D * Vol_Tet_Connectivity,
                     DOUBLE_3D * Coordinates);

INT_ ug3_p2_write_mesh (char File_Name[],
                        INT_ Write_Task_Flag,
                        INT_ Number_of_Nodes,
                        INT_ Number_of_Surf_Quads,
                        INT_ Number_of_Surf_Trias,
                        INT_ Number_of_Vol_Hexs,
                        INT_ Number_of_Vol_Pents_5,
                        INT_ Number_of_Vol_Pents_6,
                        INT_ Number_of_Vol_Tets,
                        INT_ Order,
                        INT_1D * Surf_ID_Flag,
                        INT_4D * Surf_Quad_Connectivity,
                        INT_3D * Surf_Tria_Connectivity,
                        INT_8D * Vol_Hex_Connectivity,
                        INT_1D * Vol_ID_Flag,
                        INT_5D * Vol_Pent_5_Connectivity,
                        INT_6D * Vol_Pent_6_Connectivity,
                        INT_4D * Vol_Tet_Connectivity,
                        INT_5D * P2_Surf_Quad_Connectivity,
                        INT_3D * P2_Surf_Tria_Connectivity,
                        INT_19D * P2_Vol_Hex_Connectivity,
                        INT_9D * P2_Vol_Pent_5_Connectivity,
                        INT_12D * P2_Vol_Pent_6_Connectivity,
                        INT_6D * P2_Vol_Tet_Connectivity,
                        DOUBLE_3D * Coordinates);

INT_ ug3_write_sol (char File_Name[],
                    INT_ NDim,
                    INT_ Number_of_Nodes,
                    INT_ Number_of_U_Scalars,
                    INT_ Number_of_U_Vectors,
                    INT_ Number_of_U_Metrics,
                    INT_ Number_of_U_SymMetrics,
                    DOUBLE_1D * U_Scalars,
                    DOUBLE_1D * U_Vectors,
                    DOUBLE_1D * U_Metrics,
                    DOUBLE_1D * U_SymMetrics);

void ug3_mesh_register_read_grid (INT_ (*ext_routine) (char[],
                                  INT_,
                                  INT_ *,
                                  INT_ *,
                                  INT_ *,
                                  INT_ *,
                                  INT_ *,
                                  INT_ *,
                                  INT_ *,
                                  INT_ *,
                                  INT_1D *,
                                  INT_4D *,
                                  INT_3D *,
                                  INT_8D *,
                                  INT_1D *,
                                  INT_5D *,
                                  INT_6D *,
                                  INT_4D *,
                                  DOUBLE_3D *));

void ug3_p2_mesh_register_read_grid (INT_ (*ext_routine) (char[],
                                     INT_,
                                     INT_ *,
                                     INT_ *,
                                     INT_ *,
                                     INT_ *,
                                     INT_ *,
                                     INT_ *,
                                     INT_ *,
                                     INT_ *,
                                     INT_ *,
                                     INT_1D *,
                                     INT_4D *,
                                     INT_3D *,
                                     INT_8D *,
                                     INT_1D *,
                                     INT_5D *,
                                     INT_6D *,
                                     INT_4D *,
                                     INT_5D *,
                                     INT_3D *,
                                     INT_19D *,
                                     INT_9D *,
                                     INT_12D *,
                                     INT_6D *,
                                     DOUBLE_3D *));

void ug3_mesh_register_read_func (INT_ (*ext_routine) (char[],
                                                       INT_,
                                                       INT_,
                                                       INT_ *,
                                                       INT_ *,
                                                       INT_ *,
                                                       INT_ *,
                                                       INT_ *,
                                                       CHAR_21 *,
                                                       CHAR_21 *,
                                                       CHAR_21 *,
                                                       CHAR_21 *,
                                                       DOUBLE_1D *,
                                                       DOUBLE_1D *,
                                                       DOUBLE_1D *,
                                                       DOUBLE_1D *));

void ug3_mesh_register_write_grid (INT_ (*ext_routine) (char[],
                                   INT_,
                                   INT_,
                                   INT_,
                                   INT_,
                                   INT_,
                                   INT_,
                                   INT_,
                                   INT_,
                                   INT_1D *,
                                   INT_4D *,
                                   INT_3D *,
                                   INT_8D *,
                                   INT_1D *,
                                   INT_5D *,
                                   INT_6D *,
                                   INT_4D *,
                                   DOUBLE_3D *));

void ug3_p2_mesh_register_write_grid (INT_ (*ext_routine) (char[],
                                      INT_,
                                      INT_,
                                      INT_,
                                      INT_,
                                      INT_,
                                      INT_,
                                      INT_,
                                      INT_,
                                      INT_,
                                      INT_1D *,
                                      INT_4D *,
                                      INT_3D *,
                                      INT_8D *,
                                      INT_1D *,
                                      INT_5D *,
                                      INT_6D *,
                                      INT_4D *,
                                      INT_5D *,
                                      INT_3D *,
                                      INT_19D *,
                                      INT_9D *,
                                      INT_12D *,
                                      INT_6D *,
                                      DOUBLE_3D *));

void ug3_mesh_register_write_func (INT_ (*ext_routine) (char[],
                                                        INT_,
                                                        INT_,
                                                        INT_,
                                                        INT_,
                                                        INT_,
                                                        INT_,
                                                        DOUBLE_1D *,
                                                        DOUBLE_1D *,
                                                        DOUBLE_1D *,
                                                        DOUBLE_1D *));
